##-----------------------------------------------------------------------
## 									
##        This file is part of the EMU Speech Database System
##		       (c) Copyright 1996, 1997
##	     Speech Hearing and Language Research Centre,
##	       Macquarie University, Sydney, Australia.
##
##
##                       All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## 	1. Redistributions of source code must retain the above
## 	copyright notice, this list of conditions and the following
## 	disclaimer.
##
## 	2. Redistributions in binary form must reproduce the above
## 	copyright notice, this list of conditions and the following
## 	disclaimer in the documentation and/or other materials provided
## 	with the distribution.
##
## 	3. Neither the name of Macquarie University nor the names of its
## 	contributors may be used to endorse or promote products derived
## 	from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
## IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
## TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
## PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR
## CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
## EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
## PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
## PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
## LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
## NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
## SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##-----------------------------------------------------------------------
## $Id: emu2praatTcl.tcl 04/13/04 02:17:55 tinajohn

package provide emu2praatPack 1.0
# package require padgraph
# package require trackdata
package require snackssff
package require auxwidgets
#creates new namespace 
namespace eval emu { }


namespace eval emu::e2p { 
    namespace export face emutemplatecheck e2pconvert
    #global dir [pwd]
    variable templatefile ""
    variable convfile ""
    variable ausf_inputdatei ""  
    variable outdirfile ""
    variable outdirdir ""
    variable convfile "" 
    variable initdirf ""  
    variable initdird "" 
    variable initdirdout ""
    variable warte ""
    variable prg ""
    variable pre ""
    variable prg2 ""
    variable abbruch "nein"



    proc face {{sf ".sf.ttk::frame"}} {

	#global templatefile convfile ausf_inputdatei outdirfile outdirdir convfile initdirf initdird initdirdout 
	variable templatefile ""
	variable convfile  
	variable ausf_inputdatei  
	variable outdirfile  
	variable outdirdir  
	variable convfile  
	variable initdirf  
	variable initdird  
	variable initdirdout 
	variable prg
	variable pre
	variable prg2
	variable inputfe 
	variable templatee
	variable outdirmode "MAN"
	#wm geometry $emu::x2y::tl 800x415
	#focus $emu::x2y::tl 
	ttk::frame $sf.e2pface
	set leer1 [ttk::label $sf.e2pface.leer1 -text " \n"]
	set templatel [ttk::label $sf.e2pface.templatel -text "[emu::e2p::mess template]" ]
	#-width 30
	set templatee [ttk::entry $sf.e2pface.templatee -width 30 -textvariable emu::e2p::templatefile]
	bind $sf.e2pface.templatee <Key-Return> {emu::e2p::emutemplatecheck $emu::e2p::templatefile}
	set templateb [ttk::button $sf.e2pface.templateb -text "?" -command "emu::e2p::help template"]
	# set templateOKb [ttk::button $sf.e2pface.templateOKb -text "OK" -command {emu::e2p::emutemplatecheck $emu::e2p::templatefile}]
	set templatechoose [ttk::button $sf.e2pface.templatechb -text "..." -command {emu::e2p::choosetemplate}]
	
	
	set what [ttk::label $sf.e2pface.what -text "[emu::e2p::mess what] \n 	\n"]
	set fb [ttk::button $sf.e2pface.fb -text "[emu::e2p::mess afile]" -command "emu::e2p::help file"]
	set blank1 [ttk::label $sf.e2pface.blank1 -text "  "]
	set db [ttk::button $sf.e2pface.db -text "[emu::e2p::mess adir]" -command "emu::e2p::help dir"]
	
	set inputfl [ttk::label $sf.e2pface.inputfl -text "[emu::e2p::mess Inputfile]"]
	set inputfe [ttk::entry $sf.e2pface.inputfe -textvariable emu::e2p::ausf_inputdatei -width 30]
	#bind $sf.e2pface.inputfe <KeyRelease> {puts $ausf_inputdatei}
	set inputfb [ttk::button $sf.e2pface.inputfb -text "..." -command "emu::e2p::choosefile" -width 5]
	
	set outputfl [ttk::label $sf.e2pface.outputfl -text "[emu::e2p::mess Outputdir]"]
	set outputfe [ttk::entry $sf.e2pface.outputfe -textvariable emu::e2p::outdirfile -width 30]
	#set outputfb [ttk::button $sf.e2pface.outputfb -text "..." -command "emu::e2p::choosedirf"]
	
	set outputfb [ttk::menubutton $sf.e2pface.outputfb -text "..." -width 4]
 	set om [menu $sf.e2pface.outputfb.menu]
 	$om add command -label [msgcat::mc "Automatic"]\
 	    -command emu::e2p::auto_outdir
 	$om add command -label [msgcat::mc "Extended"] -command \
 	    emu::e2p::ext_outdir
 	$om add command -label [msgcat::mc "Manual"] -command \
 	    emu::e2p::choosedirf
	$sf.e2pface.outputfb configure -menu $om
	
	
	
	set outputdl [ttk::label $sf.e2pface.outputdl -text "[emu::e2p::mess Outputdir]" ]
	set outputde [ttk::entry $sf.e2pface.outputde -textvariable emu::e2p::outdirdir -width 30]
	#set outputdb [ttk::button $sf.e2pface.outputdb -text "..." -command "emu::e2p::choosedird"]
	set outputdb [ttk::menubutton $sf.e2pface.outputdb -text "..." -width 4]
  	set om [menu $sf.e2pface.outputdb.menu -bg $emu::x2y::systemface]
  	$om add command -label [msgcat::mc "Automatic"]\
  	    -command "emu::e2p::auto_outdir 1"
  	$om add command -label [msgcat::mc "Extended"] -command \
  	    "emu::e2p::ext_outdir 1"
  	$om add command -label [msgcat::mc "Manual"] -command \
  	    emu::e2p::choosedird
	$sf.e2pface.outputdb configure -menu $om
	
	
	set startfile [ttk::button $sf.e2pface.sf -text "Start" -command "emu::e2p::startfile"]
	
	set startdir [ttk::button $sf.e2pface.sd -text "Start" -command "emu::e2p::startdir"]
	
	set contl [ttk::label $sf.e2pface.contl -text "[emu::e2p::mess converting]" ]
	set conte [entry $sf.e2pface.conte -textvariable emu::e2p::convfile -width 30 -background white]
	set leer [ttk::label $sf.e2pface.leer -text " \n"]
	set leer2 [ttk::label $sf.e2pface.leer2 -text " \n"]
	set leer3 [ttk::label $sf.e2pface.leer3 -text " " -width 5]
	
	#$templateOKb
	grid $leer1
	grid $templatel $templatee $templatechoose x x x $templateb
	grid $what - - - - - - -
	grid x $fb x x x $db x
	grid $inputfl $inputfe $inputfb x x x x
	grid $outputfl $outputfe $outputfb $leer3 $outputdl $outputde $outputdb
	grid x $startfile x x x $startdir x
	grid $contl - - - - - - x
	grid $conte - - - - - - x
	grid $leer - - - - - - x 
	grid $leer2 - - - - - - x
	grid $sf.e2pface
	#-fill both -expand 1

	ttk::frame $sf.e2pface.create -borderwidth 2 -relief sunken
	text $sf.e2pface.create.shtext -height 5 -width 40
	#pack $sf.e2pface.create.shtext
	
	#grid $emu::x2y::tln.nb.e2p.sf.e2pface.create -row 8 -column 5 -columnspan 2 -rowspan 4
	grid $emu::x2y::tln.nb.e2p.sf.e2pface.create.shtext
	
	ttk::button $sf.e2pface.create.but -text "[::msgcat::mc Close]" -command "grid forget $emu::x2y::tln.nb.e2p.sf.e2pface.create"
	grid $sf.e2pface.create.but
	#grid $emu::x2y::tln.nb.e2p.sf.e2pface.create -row 7 -column 5 -columnspan 2
	
	set prg 0
	set prg2 0
	set pre ""
	MainFrame $emu::x2y::tln.e2pmf -height 1 -bg $emu::x2y::systemface
	ttk::frame $emu::x2y::tln.e2pmf.l
	ProgressBar $emu::x2y::tln.e2pmf.l.pb -variable emu::e2p::prg -maximum 10 -width 140 -fg green
	pack $emu::x2y::tln.e2pmf.l.pb
	ProgressBar $emu::x2y::tln.e2pmf.l.pb2 -variable emu::e2p::prg2 -maximum 3 -width 140 -bg $emu::x2y::systemface
	pack $emu::x2y::tln.e2pmf.l.pb2
	ttk::label $emu::x2y::tln.e2pmf.l.pe -text $emu::e2p::pre
	pack $emu::x2y::tln.e2pmf.l.pe -anchor  c -fill x
	
	ttk::frame $emu::x2y::tln.e2pmf.r
	ttk::button $emu::x2y::tln.e2pmf.r.break -text " \n STOP \n" -command "emu::e2p::abbrechen"
	pack $emu::x2y::tln.e2pmf.r.break 
	pack $emu::x2y::tln.e2pmf.l $emu::x2y::tln.e2pmf.r -side left
	
	place $emu::x2y::tln.e2pmf -in $sf.e2pface.leer -anchor n
	$emu::x2y::tln.e2pmf showstatusbar none
    }


    proc choosetemplate { } {
	variable tpllist

	if {[winfo exists $emu::x2y::tln.labConvTpls]} {
	    destroy $emu::x2y::tln.labConvTpls
	} else {
	    set tpllistbox [uttbox .labConvTpls 1]
	    set tpllist [emutemplate]
	    uttDisplay $tpllistbox $tpllist
	    bind $tpllistbox <KeyPress> {
		emu::utils::ListboxQuickSelect %W %A
	    }
    
	    bind $tpllistbox <${emu::utils::control}-g> {
		emu::utils::ListboxQuickNext %W
	    }
	}
    }

    proc abbrechen { } {
	variable abbruch

	set abbruch "ja"
	
    }


    proc destroyallw {{sf ".sf.frame"} } {
	#global 
	variable warte
	destroy $emu::x2y::tln.e2pmf $sf.e2pface.leer $sf.e2pface.templatel $sf.e2pface.templatee $sf.e2pface.templatee $sf.e2pface.templateb $sf.e2pface.templateOKb $sf.e2pface.what $sf.e2pface.fb $sf.e2pface.blank1 $sf.e2pface.db $sf.e2pface.inputfl $sf.e2pface.inputfe $sf.e2pface.inputfe $sf.e2pface.inputfb $sf.e2pface.outputfl $sf.e2pface.outputfe $sf.e2pface.outputfb $sf.e2pface.outputdl $sf.e2pface.outputde $sf.e2pface.outputdb $sf.e2pface.sf $sf.e2pface.sd $sf.e2pface.contl $sf.e2pface.conte $sf.e2pface.leer2 $sf.e2pface.exitb $sf.e2pface  
	set warte "e2p"
	return
    }




    proc help {fileordir} {
	switch  $fileordir {
	    file {mess helpfile}
	    dir {mess helpdir}
	    template {mess helptemplate} 
	}
    }


    proc emutemplatecheck {templatefile } {
	variable templfile
	variable initdirf 
	variable initdird 
	variable ausf_inputdatei

	set templfile $templatefile
	if {$templatefile == ""} {
	    tk_messageBox -message "[mess notplselected]" \
		-type ok -parent $emu::x2y::tl -title "[mess notplselected]"
	    return 0
	}
	
	set tempcatched nix
	#fuer die Einfuehrung der emutemplate subcommands
	#die commandos beginnen freiwaehlbar immer mit templ
	catch {emutemplate templ $templfile} tempcatched
	#puts "catch schmeit bei emutemplate:  $tempcatched"
	if {$tempcatched != "templ"} {
	    tk_messageBox -message "[mess failed] \n $tempcatched \n [mess again]" \
		-type ok -parent $emu::x2y::tl -title "[mess notplselected]"
	    return 0
	} else {
	    #      tk_messageBox -message "[mess thanks]  $templfile" \
		    #         -parent $emu::x2y::tl \
		    #         -title "[mess tplselected]"
	    #      if {[file exists "$templfile.tpl" ]} {
	    #	    set initdirf [findhlbpath $templfile.tpl] 
	    #	    #set initdird $initdirf
	    #	    #set ausf_inputdatei $initdirf
	    #      }
	    return 1
	}
    }


    proc findhlbpath {filename} {
	variable tpl
	set found 1
	foreach dir [emutemplate info] {
	    set fullfname [file normalize [file join $dir $filename]]
	    if {[file exists $fullfname]} break
	}
	if {$found} {
	    set tplfile [open $fullfname r]
	    
	    while {[gets $tplfile line] >= 0} {
		switch -exact -- [lindex $line 0] {
		    path {
			set line [string map {\\ /} $line]
			foreach temp [split [lindex $line 1] ,] {
			    for {set i 2} { [expr $i < [llength $line]] } {incr i} {
				lappend temp [lindex $line $i]
			    }
			    lappend tpl(path) $temp
			}
		}
		}; #switch
	    }; #while
	    
	    set pathl [llength $tpl(path)]
	    for {set j 0} {$j < $pathl} {incr j} {
	    #---hlb
		if {"hlb" == [lindex [lindex $tpl(path) $j] 0]} {
		    set pathhlb "[lrange [lindex $tpl(path) $j] 1 end]"
		}
	    }
	return $pathhlb
	} {
	    error "Template file for $filename not found!"
	}
    }

    proc choosefile { } {
	#global ausf_inputdatei initdirf 
	variable ausf_inputdatei 
	variable initdird 
	variable initdirf
	variable uttlist

	if {[winfo exists $emu::x2y::tln.labConvUtts]} {
	    destroy $emu::x2y::tln.labConvUtts
	} else { 
	    if {$emu::e2p::templatefile != ""} {
		if {[emu::e2p::emutemplatecheck $emu::e2p::templatefile]} {
		    set uttlist [templ utterances]
		    set uttlistbox [uttbox .labConvUtts]
		    uttDisplay $uttlistbox $uttlist
		    bind $uttlistbox <KeyPress> {
			emu::utils::ListboxQuickSelect %W %A
		    }
	    
		    bind $uttlistbox <${emu::utils::control}-g> {
			emu::utils::ListboxQuickNext %W
		    }	    
		}
	    } else {
		#emutemplatecheck wasn't called before
		tk_messageBox -message "[::msgcat::mc "choose_template"]"
	    }
	}
    }


    proc uttbox {w {templ 0}} {
	variable uttw
	variable tplw
	variable inputfe
	variable templatee
	
	set comm "get_templatefile"
	set window "tplw"
	
        set mainw $emu::x2y::tln 
        
	if {$templ} {
	    set labeltext "Database"
	    set tplw [ttk::frame $mainw$w -borderwidth 2]
	    set w $mainw$w	
	    place $tplw -in $templatee  
	} else {
	    set labeltext "Utterance"
	    set uttw [ttk::frame $mainw$w -borderwidth 2]
	    set w $mainw$w
	    place $uttw -in $inputfe  
	}

	set uttbox [ttk::frame $w.uttbox]
	
	set uttlabel [ttk::label $uttbox.uttlabel -text "[::msgcat::mc $labeltext]"]

	set uttlist [listbox $uttbox.list -selectmode browse\
			 -width 27 -height 9 \
			 -bg white -yscrollcommand [list $uttbox.scroll set]\
			 -xscrollcommand [list $uttbox.scrollx set]]
	set scroll [auxwidgets::dynscrollbar $uttbox.scroll -command [list $uttlist yview]]
	set scrollx [auxwidgets::dynscrollbar $uttbox.scrollx -command [list $uttlist xview]\
			 -orient h]
	set buttbox [ttk::frame $w.buttbox]
	
	if {$templ} {
	    set buttonOK [ttk::button $buttbox.ok -text "[::msgcat::mc OK]" -default active -command {\
										     event generate $emu::e2p::tplw.uttbox.list <<getTplValueAndQuit>>} ]
	    set buttonCanc [ttk::button $buttbox.c -text "[::msgcat::mc cancel]" -command {destroy $emu::e2p::tplw} ]
	} else {
	    set buttonOK [ttk::button $buttbox.ok -text "[::msgcat::mc OK]" -default active -command {\
										     event generate $emu::e2p::uttw.uttbox.list <<getUttValueAndQuit>>} ]
	    set buttonCanc [ttk::button $buttbox.c -text "[::msgcat::mc cancel]" -command {destroy $emu::e2p::uttw} ]
	}
	
	grid $uttlabel -column 0 -sticky news 
	grid $uttlist -sticky news -column 0
	grid $uttbox.scroll -sticky ns -column 1 -row 1
	grid columnconfigure $uttbox 0 -weight 1
	grid $uttbox.scrollx -sticky ew -column 0 -row 2
	grid rowconfigure $uttbox 1 -weight 1
	grid $buttonOK $buttonCanc

	grid $uttbox -column 0 -sticky news
	grid $buttbox -column 0 -sticky ew
	grid columnconfigure $w 0 -weight 1
	grid rowconfigure $w 0 -weight 1


	bind Menu <<MenuSelect>> {
	    if {[catch {%W entrycget active -label} label]} {
		return
	    }
	    update idletasks
	}


	bind $w.uttbox.list <<getTplValueAndQuit>> {emu::e2p::get_templatefile \
							[$emu::e2p::tplw.uttbox.list curselection]; \
							destroy $emu::e2p::tplw }
	bind $w.uttbox.list <<getUttValueAndQuit>> {emu::e2p::get_ausf_inputdatei \
							[$emu::e2p::uttw.uttbox.list curselection]; \
							destroy $emu::e2p::uttw}
	
	
	
	if {$templ} {
	    bind $w.uttbox.list <Double-1> {event generate $emu::e2p::tplw.uttbox.list <<getTplValueAndQuit>> 
	    }	
	} else {
	    bind $w.uttbox.list <Double-1> {event generate $emu::e2p::uttw.uttbox.list <<getUttValueAndQuit>> 
	    }	
	} 
    
	return $uttlist
    }
    
    proc get_valueFromBox {templ } {
	if {$templ} {
	    emu::e2p::get_templatefile [$emu::e2p::tplw.uttbox.list curselection]; \
		destroy $emu::e2p::tplw
	} else {
	    emu::e2p::get_ausf_inputdatei [$emu::e2p::uttw.uttbox.list curselection]; \
		destroy $emu::e2p::uttw
	}
    }
    

    proc get_templatefile {listindex} {
	variable tpllist
	if {$listindex == ""} {return}
	set emu::e2p::templatefile [lindex $tpllist $listindex]
	emu::e2p::emutemplatecheck $emu::e2p::templatefile

    }
    
    proc get_ausf_inputdatei {listindex} {
	variable uttlist
	if {$listindex == ""} {return}
	set emu::e2p::ausf_inputdatei [lindex $uttlist $listindex]
    }
    
    proc uttDisplay {w utts} {
	$w delete 0 end
	foreach i $utts {
	    $w insert end $i
	}
    }



    proc auto_outdir {{dir 0}} {
	variable outdirfile    
	variable outdirdir
	variable outdirmode

	if {$dir} {
	    set outdirdir ~AUTOMATIC~
	} else {
	    set outdirfile ~AUTOMATIC~
	}
	set outdirmode "AUTO"
    }

    proc ext_outdir {{dir 0}} {
	variable outdirfile 
	variable initdird
	variable outdirdir
	variable initdirdout
	variable outdirmode

	if {$dir} {
	    set outdirdir [tk_chooseDirectory -title [mess outputfileExt] -initialdir [inexth $emu::e2p::initdird] \
			       -parent $emu::x2y::tl]
	    if {$outdirdir != {} && $outdirdir != "."} {
		set initdirdout $outdirdir
	    }
	} else {
	    set outdirfile [tk_chooseDirectory -title [mess outputfileExt] \
                            -initialdir [inexth $emu::e2p::initdird] \
				-parent $emu::x2y::tl]
	    if {$outdirfile != {} && $outdirfile != "."} {
		set initdird $outdirfile 
	    }
	}

	set outdirmode "EXT"

    }

    proc choosedirf { } {
	#global outdirfile initdird
	variable outdirmode
	variable outdirfile 
	variable initdird
	set outdirfile [tk_chooseDirectory -title [mess outputfile] -initialdir [inexth $emu::e2p::initdird] \
			    -parent $emu::x2y::tl]
	if {$outdirfile != {} && $outdirfile != "."} {
	    set initdird $outdirfile 
	}
	set outdirmode "MAN"
    }

    proc choosedird { } {
	#global outdirdir initdirdout
	variable outdirmode
	variable outdirdir 
	variable initdirdout

	set outdirdir [mess outputdir]	
	set initdirdout $outdirdir 
	set outdirmode "MAN"

    }

proc startfile { } {
    variable ausf_inputdatei
    variable templatefile
    	if {![emutemplatecheck $templatefile]} {
	    return 0
	}
    if {$ausf_inputdatei != ""} {
	if {![string match *\** $ausf_inputdatei] } {
	    startfile2
	} else {
	    emutemplate looptempl $templatefile
	    set utts [looptempl utterances $ausf_inputdatei]
	    foreach utt $utts {
		set ausf_inputdatei $utt
		startfile2 0
	    }
	     tk_messageBox -message "[format [mess finished] [llength $utts]]" \
			-parent $emu::x2y::tl \
			-title "[mess finishedtitle]"
	     
	     #[llength [looptempl utterances $ausf_inputdatei]]
	}
    }
    
}

    proc startfile2 {{oone 1} } {
	#global outdirfile ausf_inputdatei convfile
	variable outdirfile 
	variable outdirmode
	variable ausf_inputdatei
	variable convfile
	variable prg
	variable templfile
	variable templatefile

	#TESTS

	if {$ausf_inputdatei != ""} {
	    set Dateiname $ausf_inputdatei 
	    set uttlist [templ utterances]
	    if {[lsearch $uttlist $Dateiname] == -1} {
		tk_messageBox -message "[format [::msgcat::mc "UtteranceNotFromDatabase"] $Dateiname]"
		return 0 
	    }
	} else {
	    tk_messageBox -message "[::msgcat::mc "NoUtterance"]"  
	    return 0
	}
	if {$outdirmode == "EXT" || $outdirmode == "MAN"} {
	    if {![file isdirectory $outdirfile]} {
		mess wrongoutdir
		return 0
	    }
	}

	set pfad $outdirfile 
	#Datei exists und ist hlb
	#set Dateiname [hlbcheck $file]
	#Dateiname = Utterancename
	if {$Dateiname != 0} {
	    set prg 0
	    $emu::x2y::tln.e2pmf.l.pb configure -maximum 1
	    set convfile $Dateiname
	    if {[e2pconvert $Dateiname $pfad templ $outdirmode] != 0} {
		set prg 1
		if {$oone} {
		    tk_messageBox -message "[format [mess finished] one]" \
			-parent $emu::x2y::tl \
			-title "[mess finishedtitle]"
		}
	    }
	    return
	}

    }

    proc startdir {{oone 1}} {
	#global outdirdir convfile
	variable outdirmode
	variable outdirdir 
	variable convfile
	variable prg
	variable abbruch
	variable templfile
	variable templatefile 

	if {![emutemplatecheck $templatefile]} {
	    return 0
	}
	
	if {$outdirmode == "EXT" || $outdirmode == "MAN"} {
	    if {![file isdirectory $outdirdir]} {
		mess wrongoutdir
		return
	    }
	}

	set utts [templ utterances]
	set llength [llength $utts]
	set pfad $outdirdir
	set files 0
	set prg 0
	$emu::x2y::tln.e2pmf.l.pb configure -maximum $llength
	set abbruch "nein"
	for {set index 0} {$index < $llength} {incr index} {
	    if {$abbruch == "ja"} {
		set abbruch nein
		return
	    }
	    set Dateiname [lindex $utts $index]
	    set convfile $Dateiname
	    if {[e2pconvert $Dateiname $pfad templ $outdirmode] != 0} {
		incr files
	    }
	    incr prg
	}
	if {$oone} {
	    tk_messageBox -message "[format [mess finished] $files]" \
		-parent $emu::x2y::tl \
		-title "[mess finishedtitle]"
	}
	return

    }






    proc getstaticpart {dyn_pfad} {
	set in [string first * $dyn_pfad]
	if {$in == -1} { 
	    return $dyn_pfad/
	} else {
	    return [string range $dyn_pfad 0 [expr $in -1]] 
	}
    }

    proc e2pconvert {Dateiname pfad {templ templ} {outdirmode "MAN"} {lf 0}} {
	variable prg2
	variable templatefile 


	if {[info exists emu::x2y::tln]} {
	    set guimode [winfo exists $emu::x2y::tln.nb]
	} else {
	    set guimode 0
	}

	#test for all necessary inputs
	if {!$guimode} {
	    if {[info commands $templ] == ""} {
		#we need a templatecheck
		puts "$templ is not an emutemplate command!"
		return 0
	    }

	    if {$outdirmode == "EXT" || $outdirmode == "MAN"} {
		if {![file isdirectory $pfad]} {
		    mess wrongoutdir
		    return
		}
	    }
	    if {$Dateiname == ""} {
		puts "[::msgcat::mc "NoUtterance"]"
		return 0
	    } else {
		set uttlist [$templ utterances]
		if {[lsearch $uttlist $Dateiname] == -1} {
		    puts "[format [::msgcat::mc "UtteranceNotFromDatabase"] $Dateiname]"
		    return 0
		} 
	    }
	    
	}
	#	  tk_messageBox -message "Ciao"  
	
	#puts "guimode $guimode"
	#fuer die Einfuehrung der Hierarchy subcommands
	#templ = vom emutemplatesubcommand
	#hier damit beginnen nun frei waehlbar alle subcommands
	#die neue Hierarchy heit $Dateiname --> $Dateiname.hlb
	$templ hierarchy hier $Dateiname
	


	
	#fuer die Einfuehrung der Trackdata subcommands
	#templ = vom emutemplatesubcommand
	#trackd damit beginnen nun frei waehlbar alle subcommands
	#trackdata werden fuer $Dateiname (.wav etc.) gesucht 
	set gecatched 0
	catch { 
	    set trackd [sound snd -load [$templ resolve $Dateiname samples]] 
	} gecatched
	puts $gecatched
	#puts $trackd
	if {$lf} {
	    set levelList [$templ external_levels]
	    set allLevels $levelList
	} else {
	    #liste der Ebenen
	    set levelList [$templ getlevels]

	    #liste der Labeltypen
	    set allLevels ""
	    foreach list $levelList {
		lappend allLevels "[$templ getlabels $list]"
		#puts "$allLevels"
	    }
	}



	if {$guimode} {
	    $emu::x2y::tln.e2pmf.l.pe configure -text "[emu::e2p::mess reademufile]"
	    set prg2 1
	    set segmentlost 0
	    set lostsegments "[emu::e2p::mess notwritten] in $Dateiname:\n" 
	    grid forget $emu::x2y::tln.nb.e2p.sf.e2pface.create 
	}
	set segmentlost 0
	set lostsegments "[emu::e2p::mess notwritten] in $Dateiname:\n" 

	
	#fuer alle Ebenen in der allListe
	set tiernumber -1
	set lastMin 32000
	set lastMax 0
	#		set helpf [open c:\\segs.help w]

	foreach level $allLevels {
	    #puts "level is $level"
	    foreach label $level {
		#puts "label is $label"
		incr tiernumber
		set noPossLevel 0
		#segment oder event
		set tiertype [$templ leveltype $label]
		#puts "tiertype $tiertype"

		#Array vorbereiten level,0,0 bekommt ebenenInfo und level,0,1 #H	
		set allLevelArray($tiernumber,0,0) "$tiertype $label"
		set allLevelArray($tiernumber,0,1) "#H"
		#tk_messageBox -message "tiertype $tiertype label: $label"
		#erstelle Liste der Segmentnummern auf der Ebene
		set segList [hier segments $label]
		#puts "label $label : ___segList $segList"

		#fuer alle Elemente in der Segmentlist
		set segCount 0
		foreach seg $segList {
		    incr segCount

		    
		    #hole Liste der Zeitpunkte des Segments
		    set minMaxList [hier seginfo $seg times]
		#    if {[lindex $minMaxList 0] == 0 || [lindex $minMaxList 1] == 0} {
		#	    puts $helpf "$seg minMaxList- minMaxList : $minMaxList \n {[hier seginfo $seg label $label]} "
		#    }
		    #negative Werte suchen Ebene gegebenfalls rausschmeien-Segment wird nicht mitgeschrieben
		    if {[lsearch $minMaxList *-*]==0} {
			#incr tiernumber -1
			#set noPossLevel 1
			#puts "noPossLevel   $label"
			#break
			set segmentlost 1
			append lostsegments "Segment: [hier seginfo $seg label $label] - Level: $label \n "
			incr segCount -1
		    } else {	

			#lindex 0 nach level,segment,0 wobei preceding maxValues overwritten
			#soll nicht -> segment einfuegen
			#Anfangspunkt wurde schon beim letzten Label geschrieben
			#Endpunkt wird mit dem nchsten Segment geschrienen, was es ja auf jeden Fall gibt
			if {$segCount > 1 && $allLevelArray($tiernumber,$segCount,0) < [lindex $minMaxList 0]} {
			    #add segment
			    set allLevelArray($tiernumber,$segCount,1) "*"
			    incr segCount 
			}

			
			#many-to-many Problem
			# this can't be the case with lf = 1
			if {[lindex $minMaxList 0] == $allLevelArray($tiernumber,[expr $segCount -1],0) &&
			    [lindex $minMaxList 1] ==  $allLevelArray($tiernumber,[expr $segCount],0)} {
			    #tk_messageBox -message "heriseginfo: [hier seginfo $seg label $label] \n orglabel: $allLevelArray($tiernumber,[expr $segCount -1],1) "
			    if {[hier seginfo $seg label $label] != {}} {
				switch $allLevelArray($tiernumber,[expr $segCount -1],1) {
				    {} {append allLevelArray($tiernumber,[expr $segCount -1],1) "[hier seginfo $seg label $label]"}
				    default {append allLevelArray($tiernumber,[expr $segCount -1],1) "_[hier seginfo $seg label $label]"}
				}
			    }
			    incr segCount -1

			} else {		

			    #lindex 0 nach level,segment,0 
			    set allLevelArray($tiernumber,$segCount,0)  [lindex $minMaxList 0]
			    #hole das Label des Segments und schreibe in level,segment,0
			    if {$lf} {
				#the segnumber must be kept,because we need it for the reconvertation
				
				set allLevelArray($tiernumber,$segCount,1)  "[format %s__%s $seg [hier seginfo $seg label $label]]"
			    } else {
				set allLevelArray($tiernumber,$segCount,1)  [hier seginfo $seg label $label]
			    }
			    
			    if {$tiertype == "segment"} {
				#lindex 1 nach level,segment+1,0
				set allLevelArray($tiernumber,[expr $segCount+1],0)  [lindex $minMaxList 1]
				if {[lindex $minMaxList 1] > $lastMax} {set lastMax [lindex $minMaxList 1]}
			    } else {
				set allLevelArray($tiernumber,[expr $segCount+1],0)  [lindex $minMaxList 0]
				if {[lindex $minMaxList 0] > $lastMax} {set lastMax [lindex $minMaxList 0]}
			    }
			    if {[lindex $minMaxList 0] < $lastMin} {set lastMin [lindex $minMaxList 0]} 
			}; #many-to-many
		    }; #neg timevalues
		}; #for segment
		#if {$noPossLevel} {break}
		set allLevelArray($tiernumber,[expr $segCount +1],1) "*"
		#Anzahl der Levelsegmente array_laenge level,0,0 lappenden 
		lappend allLevelArray($tiernumber,0,0)  $segCount
		set lastSegCount $segCount
	    }; #label
	}; #level
#close $helpf
	#Anzahl der Ebenen
	set tiers [expr $tiernumber]
	#xmin und xmax des ganzen Signals
	if {$guimode} {
	    $emu::x2y::tln.e2pmf.l.pe configure -text "[emu::e2p::mess startendt]"
	    set prg2 2
	}
	

	#if {[catch {set allMin [expr [trackd start]*1000+10] } gecatched]} {set allMin $lastMin}			
	#if {[catch {set allMax [expr [trackd end]*1000+10] } gecatched]} {set allMax $lastMax}
	if {![info exists trackd]} {set trackd "There is no trackd"}
	if {$gecatched!=$trackd} {
	    #puts lala1
	    if {$guimode} {
		mess noSignal $gecatched
	    } else {
		#puts "$gecatched"
	    }
	    set allMin $lastMin			
	    set allMax $lastMax
	} else {
	    #puts lala2
	    set allMin [format %f [expr [$trackd starttime] * 1000.0]]
	    set allMax [format %f [expr $allMin + \
				       (double([lindex [$trackd info] 0]) /\
					    [lindex [$trackd info] 1] * 1000.0)]]
	}

	#--------------------ende auslesen--------------------------------------#
	#puts "guimoder $guimode"
	if {$guimode} {
	    $emu::x2y::tln.e2pmf.l.pe configure -text "[emu::e2p::mess wTextGrid]"
	    update
	    set prg2 3
	}


	# puts "#--------------------AUSGABE-------------------------------------------#"
	set Extension TextGrid

	if {$outdirmode == "EXT"} {
	    
	    set hlbpathintpl [findhlbpath [$templ name].tpl]   
	    set staticpart [getstaticpart $hlbpathintpl]
	    set uttpfad [$templ resolve $Dateiname hlb]
	    set dyn_part [string replace $uttpfad 0 [expr [string length $staticpart] -1] ""]
	    
	    set extdir $pfad
	    set newdyn_part $dyn_part
	    set dirs [file dirname $dyn_part]
	    set sepi [file nativename /]
	    
	    while {$dirs != "."} {
		set sepii [string first $sepi $newdyn_part] 
		set dir [string range $newdyn_part 0 [expr $sepii -1]]
		set extdir [file join $extdir $dir ]
		if ![file isdirectory $extdir] {
		    file mkdir $extdir
		}
		set newdyn_part [string replace $newdyn_part 0 $sepii]
		set dirs [file dirname $newdyn_part]
	    }
	    set Pfadangabe [file join $pfad [file rootname $dyn_part].$Extension]

	} elseif {$outdirmode == "AUTO"} {
	    set pfad [file rootname [$templ resolve $Dateiname hlb]]   
	    set Pfadangabe $pfad.$Extension
	} else {
	    #dyn uttnames 
	    set sepi [string last : $Dateiname]
	    if {$sepi != -1} {
		set Dateiname [string range $Dateiname [expr $sepi +1] end]
	    }
	    set NewDateiname $Dateiname.$Extension
	    set Pfadangabe [file join $pfad $NewDateiname]
	}
	
	set Pfadangabe [file nativename $Pfadangabe]
	
	
	set f [open "$Pfadangabe" "w"]

	puts $f "File type= \"ooTextFile\""
	puts $f "Object class = \"TextGrid\""
	puts $f ""
 	puts $f "xmin = [format %f [expr ($allMin-0.0)/(1000+0.0)]]"
 	puts $f "xmax = [format %f [expr ($allMax-0.0)/(1000+0.0)]]"
	puts $f ""
	puts $f "tiers? <exists>" 
	
	puts $f "size = [expr $tiers +1]"
	puts $f "item \[\]:"
	#--------header der Datei---------#
	
	#fuer alle level
	set item 0
	#parray allLevelArray

	for {set level_count 0} {$level_count <= $tiers} {incr level_count} {
	    incr item
	    set addelement 1
	    set addsomething 0
	    #extrahiere Array
	    #catch catched leere Ebenen
	    catch {
		#parray allLevelArray
		for  {set segment 0} {$segment <= [expr [lindex $allLevelArray($level_count,0,0) 2]+$addelement]} {incr segment} {
		    
		    if {$gecatched==$trackd && $segment ==1 && [lindex $levelArray(0,0) 0] == "jep_segment" && [lindex $allLevelArray($level_count,0,0) 2] > 0} { 
			set levelArray($segment,0)  $allMin
			set levelArray($segment,1)  ""
			incr addelement
			set addsomething 1
		    } else {
			set levelArray($segment,0)  $allLevelArray($level_count,[expr $segment -$addelement +1],0) 
			set levelArray($segment,1)  $allLevelArray($level_count,[expr $segment -$addelement +1],1)
		    }
		}
		if {$addsomething} {
		    set levelArray($segment,0)  $allMax
		    set levelArray($segment,1) levelArray([expr $segment -1],1)
		    set levelArray([expr $segment -1],1)  ""			
		    incr addelement
		} 

	    } lesssegments
	    #puts "less Segments geaendert XScatched: $lesssegments"
	    

	    #schreibe Array in den TextGrid file
	    #dazu Levelname=lindex 1 aus 0,0,0
	    set levelname [lindex $levelArray(0,0) 1]

	    #array_laenge = lindex 2 aus 0,0,0
	    set array_laenge [expr [lindex $levelArray(0,0) 2]+$addelement]
	    #puts "level: $levelname    Lnge: $array_laenge"
	    #item =Schleifenzaehler +1
	    #f-geoeffnete Datei 
	    if {[lindex $levelArray(0,0) 0] == "segment"} {
		w2TGinterval $Dateiname $levelname levelArray $array_laenge $f $item $allMin $allMax
	    } else { 
		w2TGtext $Dateiname $levelname levelArray $array_laenge $f $item $allMin $allMax
	    }
	    #array unset levelarray
	    
	    #parray levelArray
	    array unset levelArray
	}

	close $f
	array unset allLevelArray
	#puts "---------------------TextGrid Datei geschrieben-----------------------"
	#puts "guimode $guimode"
	if {$segmentlost} {
	    if {$guimode} {
		#$emu::x2y::tln.nb.e2p.sf.e2pface.create.shtext configure -text "$lostsegments" -background white
		$emu::x2y::tln.nb.e2p.sf.e2pface.create.shtext insert 1.0 "$lostsegments"
		#tk_messageBox -message "Lnge: [llength $lostsegments]"
		grid $emu::x2y::tln.nb.e2p.sf.e2pface.create -row 7 -column 5 -columnspan 2 -rowspan 5
		grid $emu::x2y::tln.nb.e2p.sf.e2pface.create.shtext
		#pack configure $emu::x2y::tln.sf.frame.e2pface.create -in $emu::x2y::tln.sf.frame.e2pface
	    } else {
		puts "$lostsegments"
	    }
	}
	return $Pfadangabe
    }

}; #namespace eval

#tk_messageBox -message "[mess finished]"
##exit
#::face
