package provide dbemu 0.2
package require utils

namespace eval dbemu {
    set dbemu(dbemulib) [file dirname [info script]]
    set dbemu(dbemudir) [file normalize [file join $dbemu(dbemulib) ..]]
    set dbemu(emulib) [file normalize [file join [file dirname [info script]] .. ..]]
    proc wsurf_init args {
	variable dbemu
	
	if {!$dbemu(wsurfinfo,installed)} {
	    check_existence_of_ext_progs wavesurfer 
	    if {!$dbemu(wsurfinfo,installed)} {
		if {[catch {exec wavesurfer &}]} {
		    emu::utils::messageBoxMore -message \
			"[format "[msgcat::mc needstobeinstalled]" wavesurfer wavesurfer]"\
			-title "[msgcat::mc problem]"\
			-details "directory ~/.wavesurfer/1.8/configurations not found \n wavesurfer.exe is installed to ../EMU/bin"
		    return 0
		} {
		    tk_messageBox -icon info -type ok -message [::msgcat::mc "WavesurferInitial"] \
			-detail [::msgcat::mc "WavesurferInitialLong"]
		}
	    }
	}
	set utt [$dbemu(utterance_list) get\
		     [$dbemu(utterance_list) curselection]]
	set conf_file [wsurf_config $dbemu(template) $utt]
	puts "WaveSurfer configuration written to [file normalize $conf_file]"
	set snd_file [$dbemu(template) resolve $utt samples]
	exec  wavesurfer -config $conf_file $snd_file &
	
    }

    proc wsurf_config {tpl utt} {
	variable dbemu
	set emu_plug_version 0.2
	set ex_levels [$tpl external_levels]
	set of "~/.wavesurfer/1.8/configurations/tmpconfig.conf"
	set plugins [glob -directory [file join $dbemu(dbemudir) share] \
			 "*.plug"]
	if [file exists $of] {
	    file delete $of
	}
	set h [open $of w]
	puts $h
	
	set str\
	    "\# This file is automatically generated by dbemu
set ::auto_path \[linsert \$::auto_path 0 \"$dbemu(emulib)\"\]
puts \[package require emu\]
set tpl [file root [file tail [$tpl name file]]]
emutemplate the_tpl \$tpl
the_tpl hierarchy hier $utt


\$widget configure -background \"\#d9d9d9\"
\$widget configure -foreground \"Black\"
\$widget configure -troughcolor \"\#c3c3c3\"
\$widget configure -cursorcolor \"red\"
\$widget configure -wavebarheight \"25\"
\$widget configure -pixelspersecond \"3542.86252677\"
\$widget configure -playmapfilter \"1\"

set pane \[\$widget addPane -maxheight 2048  -minheight 10\]
\$pane configure -unit \{Hz\}
\$pane configure -background \{\#d9d9d9\}
\$pane configure -showyaxis \{true\}
\$pane configure -yaxisfont \{Helvetica 10\}

if \{\[wsurf::PluginEnabled dataplot\]\} \{
\$widget dataplot::addDataPlot \$pane -stylelist \"0 red Line 1 green Line 2 blue Line 3 yellow Line\" -fileextension \".frm\" -invocation \"indirect\" -unit \"Hz\" -minvalue \"0.0\" -offset \"0.0245\"
\}

if \{\[wsurf::PluginEnabled analysis\]\} \{
\$widget analysis::addSpectrogram \$pane
\$widget analysis::addFormants \$pane
\}

set pane \[\$widget addPane -maxheight 20  -minheight 20\]
\$pane configure -height \{20\}
\$pane configure -scrollheight \{20\}
\$pane configure -background \{white\}
\$pane configure -yaxisfont \{Helvetica 10\}

if \{\[wsurf::PluginEnabled timeaxis\]\} \{
\$widget timeaxis::addTimeAxis \$pane
\}

set wsurf_PluginDir \[string trimright \[string trimleft \$wsurf::Info(PluginDir) \\{\] \\}\]

if \{!\[wsurf::PluginEnabled emu\]\} \{
file copy -force $plugins \$wsurf_PluginDir
tk_messageBox -icon info -type ok -message\
    \"Emu Plugins registered. Please start again\"
exit
\} elseif \{!\[info exists ::wsurf::Info(emu_plug_version)\]\} \{
file copy -force $plugins \$wsurf_PluginDir
tk_messageBox -icon info -type ok -message\
    \"Emu Plugins updated. Please start again.\"
exit
\} elseif \{\$wsurf::Info(emu_plug_version) < $emu_plug_version\} \{
file copy -force $plugins \$wsurf_PluginDir
tk_messageBox -icon info -type ok -message\
    \"Emu Plugins updated. Please start again\"
exit
\}
"
	puts $h $str
	foreach ll $ex_levels {
	    set fullname [$tpl resolve $utt $ll]
	    set ext [file extension $fullname]
	    set dir [file dirname $fullname]
	    set str\
"set pane \[\$widget addPane -maxheight 24  -minheight 24\]
\$pane configure -height \{24\}
\$pane configure -scrollheight \{24\}
\$pane configure -background \{white\}
\$pane configure -yaxisfont \{Helvetica 10\}


if \{\[wsurf::PluginEnabled emu\]\} \{
\$widget emu::addTranscription \$pane -extension \"$ext\" -format \"emu\" -labeldirectory \"$dir\" -autodetectformat 0 -emulevel $ll
\}
"
	    puts $h $str
	}
	close $h
	puts $of
	return [file normalize $of]
    }
}